import { DocumentNode, GraphQLSchema } from "graphql";
export declare type PublisherSchema = GraphQLSchema;
/**
 *
 * Eventbus Class
 * @class EventBus
 *
 * @param {Winston} logger Winston logger
 * @param {GraphQLSchema} publishSchema The GraphQL schema of message publisher to validated the published messaged agains
 */
export declare class EventBusValidator {
    private publisherSchema;
    private consumerTopics;
    private validator;
    private publishTopicNames?;
    constructor(props: {
        publisherSchema: GraphQLSchema;
    });
    validateConsumerQueries: (queries: DocumentNode) => Promise<string[]>;
    extractData: (topicName: string, data: {}) => Promise<any>;
    publishValidate: (props: {
        topicName: string;
        data: {};
    }) => Promise<void>;
}
