"use strict";
// import { EventBusValidator } from "./EventBusValidator";
// import { EventEmitter } from "events";
// import { EventBus, EventBusConfig } from "./EventBus";
// import { getLogger } from "./logger";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MemoryEventBus = void 0;
const tslib_1 = require("tslib");
// const logger = getLogger();
// export class MemoryEventBus implements EventBus {
//   private eventEmitter = new EventEmitter();
//   private consumeValidator!: EventBusValidator | null;
//   private publishValidator!: EventBusValidator | null;
//   constructor(public config: EventBusConfig) {
//     this.eventEmitter.setMaxListeners(100000);
//     if (config.publisher) {
//       this.publishValidator = new EventBusValidator({
//         publisherSchema: config.publisher.schema,
//       });
//     }
//     if (config.subscriber) {
//       this.consumeValidator = new EventBusValidator({
//         publisherSchema: config.subscriber.schema,
//       });
//     }
//   }
//   publish = async (args: { topicName: string; data: {} }) => {
//     if (!this.publishValidator) {
//       throw new Error("Publish config not added!");
//     }
//     await this.publishValidator.publishValidate(args);
//     this.eventEmitter.emit(`message-${args.topicName}`, args.data);
//     return;
//   };
//   init = async () => {
//     if (this.config.subscriber) {
//       if (!this.consumeValidator) {
//         throw new Error("Subcriber config not added");
//       }
//       const cb = this.config.subscriber.cb(this);
//       this.consumeValidator
//         .validateConsumerQueries(this.config.subscriber.queries)
//         .then((topics) => {
//           topics.forEach((topic) => {
//             this.eventEmitter.on(`message-${topic}`, async (data) => {
//               const extract = await this.consumeValidator?.extractData(
//                 topic,
//                 data
//               );
//               cb({ key: topic, data: extract });
//             });
//           });
//         });
//       this.eventEmitter.on("error", (e) => {
//         logger.error(e);
//       });
//     }
//   };
//   closeConsumer = async () => {
//     this.eventEmitter.removeAllListeners();
//   };
//   closePublisher = async () => {
//     return;
//   };
// }
const events_1 = require("events");
const VanillaEventBus_1 = require("./VanillaEventBus");
class MemoryEventBus {
    constructor(config) {
        var _a;
        this.config = config;
        this.eventEmitter = new events_1.EventEmitter();
        this.init = () => (0, tslib_1.__awaiter)(this, void 0, void 0, function* () {
            yield this.bus.init();
        });
        this.publish = (args) => (0, tslib_1.__awaiter)(this, void 0, void 0, function* () {
            this.eventEmitter.emit(`message-${args.topicName}`, args.data);
            yield this.bus.publish({
                topicName: args.topicName,
                data: args.data,
            }, {});
        });
        this.closeConsumer = () => (0, tslib_1.__awaiter)(this, void 0, void 0, function* () {
            this.eventEmitter.removeAllListeners();
        });
        this.closePublisher = () => (0, tslib_1.__awaiter)(this, void 0, void 0, function* () {
            return;
        });
        this.eventEmitter.setMaxListeners(100000);
        this.bus = new VanillaEventBus_1.VanillaEventBus({
            plugins: config.plugins,
            publisher: config.publisher
                ? {
                    publishClose: () => (0, tslib_1.__awaiter)(this, void 0, void 0, function* () {
                        this.eventEmitter.removeAllListeners();
                    }),
                    schema: (_a = config.publisher) === null || _a === void 0 ? void 0 : _a.schema,
                }
                : undefined,
            subscriber: this.config.subscriber
                ? {
                    cb: () => {
                        // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
                        return this.config.subscriber.cb(this);
                    },
                    getSubscription: (topic, cb) => {
                        this.eventEmitter.on(`message-${topic}`, (data) => {
                            cb(data);
                        });
                    },
                    queries: this.config.subscriber.queries,
                    schema: this.config.subscriber.schema,
                }
                : undefined,
        });
    }
}
exports.MemoryEventBus = MemoryEventBus;
