"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getPropHeaders = void 0;
const propHeadersString = "x-request-id x-b3-traceid x-b3-spanid x-b3-parentspanid x-b3-sampled x-b3-flags x-ot-span-context x-cloud-trace-context traceparent grpc-trace-bin";
const getPropHeaders = (headers) => {
    const propagateHeaders = propHeadersString
        .split(" ")
        .map((a) => a.toLowerCase());
    const result = {};
    Object.entries(headers).forEach(([key, val]) => {
        if (propagateHeaders.indexOf(key) > -1) {
            if (val && typeof val === "string") {
                result[key] = val;
            }
        }
        if (key.startsWith("x-prop-")) {
            if (val && typeof val === "string") {
                result[key] = val;
            }
        }
    });
    return result;
};
exports.getPropHeaders = getPropHeaders;
